﻿
var strGetGroupData = "";
var strAddGroup = "";
var strDeleteGroup = "";
var strUpdateGroupPolicy = "";



function fnLoadGroupData(strGroupName) {
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: strGetGroupData,
        data: { strGroupName: strGroupName },
        type: 'GET',
        success: function (data) {
            $('#overlay').hide();
            
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = Boolean(eval(jSon['result']));
                if (bResult == true) {
                    var strJsonText = jSon['message'];
                    
                    fnLoadJsonData(strJsonText);
                    strSelectedGroup = strGroupName;
                }
                else {
                    webix.alert({
                        title: "Group Update Error",
                        ok: "OK",
                        text: jSon['message']
                    });
                }
            }
            else {
                webix.alert({
                    title: "Group Update Error",
                    ok: "OK",
                    text: ' Unable to get the data for the group. Please logout and login again'
                });
            }

        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            webix.alert({
                title: "Group Update Error",
                ok: "OK",
                text: "Status: " + textStatus + "Error: " + errorThrown
            });
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};

function fnAddGroup() {


    var form1 = {
        id: "groupName", view: "form", borderless: !0, elements: [{ view: "text", label: "Group Name", name: "Group Name", attributes: { maxlength: 25 } }
        , {
            cols: [{
                view: "button", value: "Create", click: function () {
                    var dialogWindow = this.getTopParentView();
                    var n = this.getParentView().getParentView().getValues();

                    strGroupName = n["Group Name"];

                    // Create overlay and append to body:
                    $('<div id="overlay"/>').css({
                        position: 'fixed',
                        top: 0,
                        left: 0,
                        width: '100%',
                        height: $(window).height() + 'px',
                        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
                        opacity: 0.90
                    }).hide().appendTo('body');

                    // SHOW overlay
                    $('#overlay').show();
                    $.ajax({
                        cache: false,
                        url: strAddGroup,
                        data: { strGroupName: strGroupName },
                        type: 'GET',
                        success: function (data) {
                            if (data != '') {
                                $('#overlay').hide();
                                var jSon = JSON.parse([data]);
                                var bResult = Boolean(eval(jSon['result']));
                                if (bResult == true) {
                                    // Lets add the new group to the list of groups
                                    var x = document.getElementById("group_selectable");
                                    var option = document.createElement("option");
                                    option.text = strGroupName;
                                    option.value = strGroupName;
                                    x.add(option);
                                    $("#group_selectable").val(strGroupName);
                                    fnLoadGroupData(strGroupName);
                                }
                                else {
                                    webix.alert({
                                        title: "Group Addition Error",
                                        ok: "OK",
                                        text: jSon['message']
                                    });
                                }
                            }

                        },
                        complete: function () {
                            // Hide the processing gif
                            $('#overlay').hide();
                            dialogWindow.hide();
                        }
                    });
                }
            },
            {
                view: "button", value: "Cancel", click: function () { this.getParentView().getTopParentView().hide() }
            }]
        }]
        , elementsConfig: { labelPosition: "left", labelWidth: 120 }
    };

    webix.ui({ view: "window", id: "GroupDefinitionWin", width: 500, position: "center", modal: !0, head: "Add New Group", body: webix.copy(form1) }).show();



};

function fnDeleteGroup() {

    var strGroupName = strSelectedGroup;
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: strDeleteGroup,
        data: { strGroupName: strGroupName },
        type: 'GET',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var strResult = jSon['result'];
                if (Boolean(eval(strResult.toLowerCase())) == true) {
                    // Lets remove new group to the list of groups
                    $("#group_selectable option[value='" + strSelectedGroup + "']").remove();
                    $("#group_selectable").val("DEFAULT GROUP");
                    fnLoadGroupData("DEFAULT GROUP");
                }
                else {
                    webix.alert({
                        title: "Group Deletion Error",
                        ok: "OK",
                        text: jSon['message']
                    });
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};

// This function loads the JSON data in the controls
function fnUpdateGroupPolicy() {
    if (strSelectedGroup != undefined) {
        if (strSelectedGroup != '') {
            var strGroupName = strSelectedGroup;
            // Create overlay and append to body:
            $('<div id="overlay"/>').css({
                position: 'fixed',
                top: 0,
                left: 0,
                width: '100%',
                height: $(window).height() + 'px',
                background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
                opacity: 0.90
            }).hide().appendTo('body');


            var changeJSONString = JSON.stringify(changeJSON);
            var strFeaturesJSON = fnGetFeaturesJSON();

            var jSonData = {
                user_group: strSelectedGroup
                , change: Base64.encode(changeJSONString)
                , feature_xml: Base64.encode(strFeaturesJSON)
            };

            // SHOW overlay
            $('#overlay').show();
            $.ajax({
                cache: false,
                url: strUpdateGroupPolicy,
                data: jSonData,
                type: 'POST',
                success: function (data) {
                    $('#overlay').hide();
                    if (data != '') {
                        var jSon = JSON.parse(data);
                        var strResult = jSon['result'];
                        if (Boolean(eval(strResult.toLowerCase())) == false) {
                            webix.alert({
                                title: "Group Policy Update Error",
                                ok: "OK",
                                text: jSon['message']
                            });
                        }
                        else {
                            var options = {};
                            options['closeButton'] = true;
                            options['positionClass'] = "toast-top-right";
                            options['type'] = "success";
                            var title = "";
                            toastr[options.type]("Group Policy Updated", title, options);
                            bDirtyFlag = false;
                        }
                    }
                },
                complete: function () {
                    // Hide the processing gif
                    $('#overlay').hide();
                }
            });
        }
    }
};

function updateTips(t) {
    $(".validateTips")
      .text(t)
      .addClass("ui-state-highlight");
    setTimeout(function () {
        $(".validateTips").removeClass("ui-state-highlight", 1500);
    }, 500);
};

function checkLength(o, n, min, max) {
    if (o.val().length > max || o.val().length < min) {
        o.addClass("ui-state-error");
        updateTips("Length of " + n + " must be between " +
          min + " and " + max + ".");
        return false;
    } else {
        return true;
    }
};

function checkRegexp(o, regexp, n) {
    if (!(regexp.test(o.val()))) {
        o.addClass("ui-state-error");
        updateTips(n);
        return false;
    } else {
        return true;
    }
};

$(document).ready(function () {

    $('#addGroup').click(function () {
        fnAddGroup();
    });

    $('#deleteGroup').click(function () {
        webix.modalbox({
            title: "Group Deletion",
            buttons: ["Yes", "No"],
            text: "Do you want to delete the selected group?",
            width: 500,
            callback: function (result) {
                switch (result) {
                    case "0":
                        fnDeleteGroup();
                        break;
                    case "1":
                        //statement
                        break;
                }
            }
        });
    });

    $('#updatePolicy').click(function () {
        fnUpdateGroupPolicy();
    });


});

