﻿$('#updatePolicy').click(function () {
    fnUpdateInvidualConfiguration();
});

// This function loads the JSON data in the controls
function fnUpdateInvidualConfiguration() {
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    var changeJSONString = JSON.stringify(changeJSON);
    var strFeaturesJSON = fnGetFeaturesJSON();
    var jSonData = {
        change: Base64.encode(changeJSONString),
        feature_xml: Base64.encode(strFeaturesJSON)
    };

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: strUpdateConfig,
        data: jSonData,
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse(data);
                var strResult = jSon['result'];
                if (Boolean(eval(strResult.toLowerCase())) == false) {
                    webix.alert({
                        title: "Configuration Update Error",
                        ok: "OK",
                        text: jSon['message']
                    });
                }
                else {
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-right";
                    options['type'] = "success";
                    var title = "";
                    toastr[options.type]("Configuration Updated", title, options);
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};