﻿
var iconDrag = "<span class='webix_icon fa-bars'></span>";
var iconEditplicy = "<span class='webix_icon fa-pencil ruleedit1'></span>";
var iconDelete = "<span class='webix_icon fa-trash'></span>";
var iconCopy = "<span class='webix_icon fa-copy'></span>";
var iconInfo = "<span class='webix_icon fa-info-circle'></span>";

var rulecopy = [];

var rule_options = [{ id: 0, value: "Select condition" },
{ id: 1, value: "The sender is..." },
{ id: 2, value: "The sender address contains..." },
{ id: 3, value: "The recipient is..." },
{ id: 4, value: "The recipient address contains..." },
{ id: 5, value: "GSG only - The email header contains..." },
{ id: 6, value: "The subject contains..." },
{ id: 7, value: "The body contains..." },
{ id: 8, value: "The body contains any credit card number" },
{ id: 9, value: "The email contains one or more attachments" },
{ id: 10, value: "Office attachments' classification contains..." },
{ id: 11, value: "Any email attachment filename contains..." },
{ id: 12, value: "Triggered by classification software" }];

var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (n) { var f = "", e, t, i, s, h, o, r, u = 0; for (n = Base64._utf8_encode(n); u < n.length;) e = n.charCodeAt(u++), t = n.charCodeAt(u++), i = n.charCodeAt(u++), s = e >> 2, h = (e & 3) << 4 | t >> 4, o = (t & 15) << 2 | i >> 6, r = i & 63, isNaN(t) ? o = r = 64 : isNaN(i) && (r = 64), f = f + this._keyStr.charAt(s) + this._keyStr.charAt(h) + this._keyStr.charAt(o) + this._keyStr.charAt(r); return f }, decode: function (n) { var t = "", e, o, s, h, u, r, f, i = 0; for (n = n.replace(/[^A-Za-z0-9\+\/\=]/g, ""); i < n.length;) h = this._keyStr.indexOf(n.charAt(i++)), u = this._keyStr.indexOf(n.charAt(i++)), r = this._keyStr.indexOf(n.charAt(i++)), f = this._keyStr.indexOf(n.charAt(i++)), e = h << 2 | u >> 4, o = (u & 15) << 4 | r >> 2, s = (r & 3) << 6 | f, t = t + String.fromCharCode(e), r != 64 && (t = t + String.fromCharCode(o)), f != 64 && (t = t + String.fromCharCode(s)); return Base64._utf8_decode(t) }, _utf8_encode: function (n) { var i, r, t; for (n = n.replace(/\r\n/g, "\n"), i = "", r = 0; r < n.length; r++) t = n.charCodeAt(r), t < 128 ? i += String.fromCharCode(t) : t > 127 && t < 2048 ? (i += String.fromCharCode(t >> 6 | 192), i += String.fromCharCode(t & 63 | 128)) : (i += String.fromCharCode(t >> 12 | 224), i += String.fromCharCode(t >> 6 & 63 | 128), i += String.fromCharCode(t & 63 | 128)); return i }, _utf8_decode: function (n) { for (var r = "", t = 0, i = c1 = c2 = 0; t < n.length;) i = n.charCodeAt(t), i < 128 ? (r += String.fromCharCode(i), t++) : i > 191 && i < 224 ? (c2 = n.charCodeAt(t + 1), r += String.fromCharCode((i & 31) << 6 | c2 & 63), t += 2) : (c2 = n.charCodeAt(t + 1), c3 = n.charCodeAt(t + 2), r += String.fromCharCode((i & 15) << 12 | (c2 & 63) << 6 | c3 & 63), t += 3); return r } };
function showFormRule(n, t, i) {
    $$(n).getBody().focus();
    $$(n).show();
    if (i != -1) {
        var r = t[i];
        var ruledataDecoded = "";
        if (r.ruledata != "") {
            ruledataDecoded = Base64.decode(r.ruledata);
        }
        r.description = r.description.replace("&amp;", "&");
        r.description = r.description.replace("&lt;", "<");
        r.description = r.description.replace("&gt;", ">");
        $$("ruleForm").setValues({
            "description": r.description,
            "rule": r.rule,
            "ruledata": ruledataDecoded,
            "outlook": r.outlook,
            "gsg": r.gsg,
            "audit": r.audit,
            "enabled": r.enabled,
            "index": r.index
        });
        nCurrentIndex = i
    }
    else {
        $$("ruleForm").setValues({
            "description": "New Rule",
            "rule": 0,
            "ruledata": "",
            "outlook": 1,
            "gsg": 1,
            "audit": 1,
            "enabled": 1,
            "index": -1
        });
    }


}

function copyRules() {
    rulecopy = [];
    for (i = 0; i < ruleJSON.length; i++) {
        rulecopy.push({
            "description": ruleJSON[i].description,
            "rule": ruleJSON[i].rule,
            "ruledata": ruleJSON[i].ruledata,
            "outlook": ruleJSON[i].outlook,
            "gsg": ruleJSON[i].gsg,
            "audit": ruleJSON[i].audit,
            "enabled": ruleJSON[i].enabled,
            "index": i
        });
    }
    if (rulecopy.length > 0) {
        $$("pastebuttonForPolicyRules").enable();
        webix.message({ type: "error", text: rulecopy.length.toString() + " rule/s copied" })
    }
    else {
        $$("pastebuttonForPolicyRules").disable();
    }
}

function fnGetUniqueName(name) {
    var bPresent = false;
    for (i = 0; i < ruleJSON.length; i++) {
        if (ruleJSON[i].description == name) {
            bPresent = true;
        }
    }
    if (bPresent == true) {
        var nSuf = 1;
        try {
            // Get the last part of the name, if the part is a number, we will increment it
            var pos = name.lastIndexOf(' ');
            if (pos != -1) {
                var strSuffix = name.substring(pos + 1);
                if (strSuffix != undefined && isNaN(strSuffix) == false) {
                    var nV = parseInt(strSuffix);
                    nSuf = nV + 1;
                    name = name.substring(0, pos);
                }
            }
        }
        catch (e) {
            // Do nothing
        }

        // Limit the length of name to 28 characters
        if (name.length > 28) {
            name = name.substring(0, 28);
        }
        name = name + " " + nSuf.toString();
        return fnGetUniqueName(name);
    }
    return name;
}

function pasteRules() {
    var len = rulecopy.length;
    if (len > 0) {
        webix.confirm("Do you want to paste " + len.toString() + " rule/s in this list?", function (result) {
            if (result == true) {
                for (var i = 0; i < rulecopy.length; i++) {
                    var rname = rulecopy[i].description;
                    // Check if the rule name is already present
                    rname = fnGetUniqueName(rname);
                    ruleJSON.push({
                        "description": rname,
                        "rule": rulecopy[i].rule,
                        "ruledata": rulecopy[i].ruledata,
                        "outlook": rulecopy[i].outlook,
                        "gsg": rulecopy[i].gsg,
                        "audit": rulecopy[i].audit,
                        "enabled": rulecopy[i].enabled,
                        "index": ruleJSON.length
                    });
                }
                bDirtyFlag = true;
                $$("policyListing").clearAll();
                $$("policyListing").parse(ruleJSON);
            }
        })
    }
    else {
        $$("pastebuttonForPolicyRules").disable();
    }
}

var nCurrentIndex = -1;
var nTableId = -1;
var nRowID = -1;
var ruleJSON = [];



webix.ready(function () {


    webix.ui({ view: "popup", id: "help_email", width: 500, height: 150, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Email Address<\/b>:<br/>Enter a valid email address<br/>" }] } } });
    webix.ui({ view: "popup", id: "help_text", width: 500, height: 300, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Text Search<\/b>:<br/>For performing simple text search, enter the text. The search is case insensitive.<br/><br/><b>Regular Expressions<\/b>:<br/>For performing regular expression search enter the search expression prefixed by the word <b>REG:<\/b><br/>For eg.<br/>REG:^[A-Z0-9._%+-]+@[A-Z0-9.-]+.[A-Z]{2,}$<br/>" }] } } });
    webix.ui({ view: "popup", id: "help_key_value", width: 500, height: 300, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Key:Value<\/b>:<br/>Enter a key:value pair for searching. <br/><br/> For eg.<br/>X-Data:CorporateEmail<br/><br/>" }] } } });


    var form = {
        id: "ruleForm", view: "form", borderless: !0, elements: [{ view: "text", label: "Rule Name", name: "description", attributes: { maxlength: 30 } },
        {
            view: "select", label: "Encrypt if", name: "rule", options: rule_options, on: {
                onChange: function (n) {
                    var i = this.getFormView();
                    t = i.elements.ruledata;
                    o = i.elements.outlook;
                    g = i.elements.gsg;
                    g.enable();
                    if (n == 8 || n == 9) {
                        t.disable(); t.setValue("");
                        o.enable();
                    }
                    else if (n == 5) {
                        o.disable(); o.setValue(0);
                    }
                    else if (n == 12) {
                        t.disable(); t.setValue("");
                        o.enable();
                        g.disable(); g.setValue(0);
                    }
                    else {
                        t.enable();
                        o.enable();
                        g.enable();
                    }
                }
            }
        },
        {
            cols: [{ id: "helpbutton", view: "text", label: "Rule Data", name: "ruledata" },
            {
                view: "icon", width: 20, template: iconInfo, on: {
                    onItemClick: function () {
                        var n = this.getParentView().getParentView().getValues();
                        if (n.rule != 8 && n.rule != 9 && n.rule != 12) {
                            if (n.rule == 1 || n.rule == 3) {
                                $$("help_email").show(this.$view)
                            }
                            else if (n.rule == 5 || n.rule == 10) {
                                $$("help_key_value").show(this.$view)
                            }
                            else {
                                $$("help_text").show(this.$view)
                            }

                        }
                    }
                }
            }]
        },
        {
            cols: [{ view: "checkbox", label: "Outlook", name: "outlook", value: 1 },
            { view: "checkbox", label: "Secure Gateway", name: "gsg", value: 1 }]
        },
        {
            cols: [{ view: "checkbox", label: "Auditable", name: "audit" },
            { view: "checkbox", label: "Enable policy", name: "enabled", value: 1 }]
        },
        {
            cols: [{
                view: "button", value: "Save", click: function () {
                    if (this.getParentView().getParentView().validate()) {
                        webix.message("All is correct");

                        var n = this.getParentView().getParentView().getValues();
                        n.description = $.trim(n.description);
                        n.description = n.description.replace("&", "&amp;");
                        n.description = n.description.replace("<", "&lt;");
                        n.description = n.description.replace(">", "&gt;");

                        if (n.ruledata != undefined && n.ruledata != "") {
                            n.ruledata = Base64.encode(n.ruledata);
                        }
                        else {
                            n.ruledata = "";
                        }
                        if (nCurrentIndex != -1) {
                            n.index = nCurrentIndex;
                            ruleJSON[nCurrentIndex] = n;
                        }
                        else {
                            n.index = ruleJSON.length;
                            ruleJSON.push(n);
                        }
                        bDirtyFlag = true;
                        $$("policyListing").clearAll();
                        $$("policyListing").parse(ruleJSON);
                        this.getTopParentView().hide()
                    }
                    else webix.message({ type: "error", text: "Form data is invalid" })
                }
            },
            {
                view: "button", value: "Cancel", click: function () { this.getParentView().getTopParentView().hide() }
            }]
        }], rules: {
            description: function (n) {
                // Lets trim the rule name
                n = $.trim(n);
                n = encodeURIComponent(n);
                if (n != undefined && n != "") {
                    for (i = 0; i < ruleJSON.length; i++) if (nCurrentIndex != i) {
                        var t = ruleJSON[i]; if (encodeURIComponent(t.description) == n) return webix.message({ type: "error", text: "The rule name is already defined!" }),
                            !1
                    }
                    return !0
                }
                return !1
            },
            rule: function (n) {
                return webix.rules.isNumber && n > 0;
            },
            ruledata: function (n) {
                var bReturn = true;
                if (n == undefined) {
                    bReturn = false;
                }
                if (n == "") {
                    bReturn = false;
                }
                // Check if the rule is for email validation then we will do email validation
                var rule = this.elements.rule.getValue();
                if (rule == 1 || rule == 3) {
                    bReturn = (/^['a-zA-Z0-9._-]+@([a-zA-Z0-9.-]+\.)+[a-zA-Z0-9.-]{2,10}$/).test((n || "").toString());
                }
                return bReturn;
            }
        },
        elementsConfig: { labelPosition: "left", labelWidth: 120 }
    };


    webix.ui({ view: "window", id: "RuleDefinitionWin", width: 500, position: "center", modal: !0, head: "Policy Rule Definition", body: webix.copy(form) });


    if ($("#policymanager").length > 0) {
        var policyGrid = webix.ui({
            container: "policymanager",
            rows: [
                {
                    view: "toolbar",
                    id: "ruleToolbar", height: 42,
                    cols: [
                        { view: "label", type: "icon", label: "Encryption Rules", width: 150, align: "left" },
                        { gravity: 2 },
                        { id: "pastebuttonForPolicyRules", view: "button", type: "icon", icon: "paste", label: "Paste", click: "pasteRules();", disabled: true },
                        { id: "copybuttonForPolicyRules", view: "button", type: "icon", icon: "copy", label: "Copy all", click: "copyRules();" },
                        { view: "button", type: "icon", icon: "plus", label: "Add new", click: "nCurrentIndex=-1;showFormRule('RuleDefinitionWin', ruleJSON, -1)" }
                    ]
                },
                {
                    id: 'policyListing',
                    autoheight: true,
                    autowidth: true,
                    view: "datatable",
                    columns: [
                        { id: "description", header: "Rule Name", width: 200 },
                        { id: "status", header: "Status", width: 55, template: function (obj) { return (obj.enabled == 1) ? "Active" : "Inactive"; }, css: { "text-align": "center" } },
                        { id: "outlook", header: "Outlook", width: 70, template: function (obj) { return (obj.outlook == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                        { id: "gsg", header: "Secure Gateway", width: 70, template: function (obj) { return (obj.gsg == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                        { id: "audit", header: "Auditable", width: 75, template: function (obj) { return (obj.audit == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                        { id: "action", header: "", width: 80, template: iconCopy + iconDelete + iconEditplicy, css: { "text-align": "center" } }
                    ],
                    onClick: {
                        "ruleedit1": function (e, id) {
                            nCurrentIndex = this.getItem(id).index;
                            showFormRule("RuleDefinitionWin", ruleJSON, this.getItem(id).index);
                        },
                        "fa-copy": function (e, id) {
                            nCurrentIndex = this.getItem(id).index;
                            rulecopy = [];
                            rulecopy.push({
                                "description": ruleJSON[nCurrentIndex].description,
                                "rule": ruleJSON[nCurrentIndex].rule,
                                "ruledata": ruleJSON[nCurrentIndex].ruledata,
                                "outlook": ruleJSON[nCurrentIndex].outlook,
                                "gsg": ruleJSON[nCurrentIndex].gsg,
                                "audit": ruleJSON[nCurrentIndex].audit,
                                "enabled": ruleJSON[nCurrentIndex].enabled,
                                "index": 0
                            });
                            if (rulecopy.length > 0) {
                                $$("pastebuttonForPolicyRules").enable();
                                webix.message({ type: "error", text: "One rule copied" })
                            }
                            else {
                                $$("pastebuttonForPolicyRules").disable();
                            }
                        },
                        "fa-trash": function (e, id) {
                            nTableId = this.getItem(id).index;
                            nRowID = id;
                            webix.confirm("Do you want to delete the rule: " + this.getItem(id).description + "?", function (result) {
                                if (result == true) {
                                    for (var i = ruleJSON.length - 1; i >= 0; i--) {
                                        if (ruleJSON[i].index == nTableId) {
                                            ruleJSON.splice(i, 1);
                                            $$("policyListing").remove(nRowID);
                                            break;
                                        }
                                    }
                                    // Update the index
                                    for (var i = ruleJSON.length - 1; i >= 0; i--) {
                                        ruleJSON[i].index = i;
                                    }
                                    bDirtyFlag = true;
                                }
                            })
                        }

                    }
                }
            ]
        });


        $$("policyListing").parse(ruleJSON);
    }
});