﻿var arrFeaturesList = Array();
var changeJSON = Array();
var bDirtyFlag = false;
var strSelectedGroup = 'DEFAULT GROUP';
var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (n) { var f = "", e, t, i, s, h, o, r, u = 0; for (n = Base64._utf8_encode(n) ; u < n.length;) e = n.charCodeAt(u++), t = n.charCodeAt(u++), i = n.charCodeAt(u++), s = e >> 2, h = (e & 3) << 4 | t >> 4, o = (t & 15) << 2 | i >> 6, r = i & 63, isNaN(t) ? o = r = 64 : isNaN(i) && (r = 64), f = f + this._keyStr.charAt(s) + this._keyStr.charAt(h) + this._keyStr.charAt(o) + this._keyStr.charAt(r); return f }, decode: function (n) { var t = "", e, o, s, h, u, r, f, i = 0; for (n = n.replace(/[^A-Za-z0-9\+\/\=]/g, "") ; i < n.length;) h = this._keyStr.indexOf(n.charAt(i++)), u = this._keyStr.indexOf(n.charAt(i++)), r = this._keyStr.indexOf(n.charAt(i++)), f = this._keyStr.indexOf(n.charAt(i++)), e = h << 2 | u >> 4, o = (u & 15) << 4 | r >> 2, s = (r & 3) << 6 | f, t = t + String.fromCharCode(e), r != 64 && (t = t + String.fromCharCode(o)), f != 64 && (t = t + String.fromCharCode(s)); return Base64._utf8_decode(t) }, _utf8_encode: function (n) { var i, r, t; for (n = n.replace(/\r\n/g, "\n"), i = "", r = 0; r < n.length; r++) t = n.charCodeAt(r), t < 128 ? i += String.fromCharCode(t) : t > 127 && t < 2048 ? (i += String.fromCharCode(t >> 6 | 192), i += String.fromCharCode(t & 63 | 128)) : (i += String.fromCharCode(t >> 12 | 224), i += String.fromCharCode(t >> 6 & 63 | 128), i += String.fromCharCode(t & 63 | 128)); return i }, _utf8_decode: function (n) { for (var r = "", t = 0, i = c1 = c2 = 0; t < n.length;) i = n.charCodeAt(t), i < 128 ? (r += String.fromCharCode(i), t++) : i > 191 && i < 224 ? (c2 = n.charCodeAt(t + 1), r += String.fromCharCode((i & 31) << 6 | c2 & 63), t += 2) : (c2 = n.charCodeAt(t + 1), c3 = n.charCodeAt(t + 2), r += String.fromCharCode((i & 15) << 12 | (c2 & 63) << 6 | c3 & 63), t += 3); return r } };

// This function loads the JSON data in the controls
function fnLoadJsonData(jsonData) {
    if (jsonData != undefined) {
        if (jsonData != '') {
            try {
                arrFeaturesList = Array();
                changeJSON = Array();
                bDirtyFlag = false;

                var productTable = $("#product_table");
                productTable.empty();
                var configData = jsonData['feature_extended_conf_data'];
                var products = jsonData['products'];

                var headerRow = "";
                if (products.length > 0) {
                    headerRow += "<thead>";
                    headerRow += "<tr>";
                    headerRow += "<th class=\"text-left\">Feature</th>";
                }
                for (i = 0; i < products.length; i++) {
                    headerRow += "<th class=\"text-center\">" + products[i]["description"] + "</th>";
                }
                if (products.length > 0) {
                    headerRow += "</tr>";
                    headerRow += "</thead>";
                }
                productTable.append(headerRow);

                for (i = 0; i < products.length; i++) {
                    var features = products[i].features;
                    for (j = 0; j < features.length; j++) {
                        var bFound = false;
                        for (k = 0; k < arrFeaturesList.length; k++) {
                            if (arrFeaturesList[k].code == features[j].code) {
                                bFound = true;
                                break;
                            }
                        }
                        if (bFound == false) {
                            arrFeaturesList.push({ "name": features[j].name, "code": features[j].code, "ids": "" });
                        }
                    }
                }

                productTable.append("<tbody>");
                for (i = 0; i < arrFeaturesList.length; i++) {
                    var row = "<tr>";
                    row += "<td class=\"text-left\">" + arrFeaturesList[i].name + "</td>";
                    for (j = 0; j < products.length; j++) {
                        var state = "False";
                        var bFound = false;
                        for (k = 0; k < products[j].features.length; k++) {
                            if (products[j].features[k].code == arrFeaturesList[i].code) {
                                state = products[j].features[k].bEnabledForTheGroup;
                                bFound = true;
                                break;
                            }
                        }
                        if (bFound == true) {
                            var switchID = Base64.encode(strSelectedGroup + "_" + products[j].description + "_" + arrFeaturesList[i].code);
                            switchID = switchID.replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
                            row += "<td class=\"text-center\">";
                            row += "<label class=\"switch switch-primary\"><input id=\"" + switchID + "\" class=\"switch-input  featureToggle\" type=\"checkbox\" ";
                            if (state == "True") {
                                row += "checked=\"checked\"";
                            }
                            row += ">";
                            row += "<span class=\"switch-track\"></span><span class=\"switch-thumb\"></span></label>";
                            row += "</td>";

                            // Add the id to the feature list
                            var strIds = arrFeaturesList[i].ids;
                            if (strIds != "") {
                                strIds += ",";
                            }
                            strIds += switchID;
                            arrFeaturesList[i].ids = strIds;
                        }
                        else {
                            row += "<td class=\"text-center\">&nbsp;</td>";
                        }
                    }
                    row += "</tr>";

                    productTable.append(row);


                    fnProcessExtendedFeatureHandler(arrFeaturesList[i].code);
                }
                productTable.append("</tbody>");
                 if (configData != undefined) {
                    if (configData != "") {
                        fnSetFeaturesJSON(Base64.decode(configData));
                    }
                 }
                 if ($("#L14F1").is(':visible') == true) {
                     var GSG = $("#L14F1").val();
                     if(GSG == undefined || GSG == '')
                     {
                         GSG = generateRandomString();
                         $("#L14F1").val(GSG);
                     }
                 }

            } catch (e) {
                // Do nothing
                console.log(e.message);
            }

        }
    }
};


// Function to record changes in the switches of the product features
$(document).on('click', '.featureToggle', function (e) {
    bDirtyFlag = true;
    var id = this.getAttribute("id");
    var ch = this.checked;
    if (id != undefined && ch != undefined && changeJSON != undefined) {
        try {
            if (id.length % 4 != 0)
                id += ('===').slice(0, 4 - (id.length % 4));
            id = id.replace(/-/g, '+').replace(/_/g, '/');
            var idData = Base64.decode(id);
            var elements = idData.split("_");
            var strGroupName = elements[0];
            var strProduct = elements[1];
            var strFeatureCode = elements[2];

            var bFound = false;
            for (i = 0; i < changeJSON.length; i++) {
                if (changeJSON[i].id == id) {
                    changeJSON[i].value = ch;
                    bFound = true;
                    break;
                }
            }
            if (bFound == false) {
                changeJSON.push({ "id": id, "value": ch });
            }

            // Call feature code processing to turn on or off a feature
            fnProcessExtendedFeatureHandler(strFeatureCode);
        } catch (e) {
            // Do nothing

        }
    }
});

// This function enables or disables the extended configuration based on the selection
function fnProcessExtendedFeatureHandler(strFeatureCode) {
    try {
        var bShow = false;
        for (i = 0; i < arrFeaturesList.length; i++) {
            if (arrFeaturesList[i].code == strFeatureCode) {
                var arrIds = arrFeaturesList[i].ids.split(",");
                for (j = 0; j < arrIds.length; j++) {
                    var selectedID = '#' + arrIds[j];
                    var cont = $()
                    var satisfied = $(selectedID).prop('checked');
                    if (satisfied == true) {
                        bShow = true;
                        break; // found atleast on true parameter
                    }
                }
                break;
            }
        }
        if (bShow == true) {
            if (strFeatureCode != "L14") {
                $("#EXT_" + strFeatureCode).hide();
            }
            else {
                $("#EXT_" + strFeatureCode).show(250);
            }
        }
        else {
            $("#EXT_" + strFeatureCode).hide(250);
        }

        
        if ($("#EXT_G").is(':visible') == true) {
            $("#EXT_G").hide();
        }
    } catch (e) {
        console.log(e.message);
    }
}

// This function returns the string of the extended parameters
function fnGetFeaturesJSON() {
    var strReturnValue = "{";
    try {       
        if ($("#EXT_L14").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L14\":{";
            strReturnValue += "\"L14F1\":\"" + $("#L14F1").val() + "\"";
            strReturnValue += "}";
        }
    } catch (e) {
        console.log(e.message);
    }
    strReturnValue += "}";
    return strReturnValue;
};

// This function sets the values of the loaded JSON
function fnSetFeaturesJSON(strFeaturesJSON) {
    try {
        var featuresJSON = JSON.parse(strFeaturesJSON);
        if (featuresJSON != undefined) {
            if (featuresJSON.L14 != undefined) {
                if (featuresJSON.L14.L14F1 != undefined) {
                    if (featuresJSON.L14.L14F1 == "")
                    {
                        // Generate a GSG Code
                        featuresJSON.L14.L14F1 = generateRandomString();
                    }
                    $("#L14F1").val(featuresJSON.L14.L14F1);
                }
            }
        }
    } catch (e) {
        console.log(e.message);
    }
}

function generateRandomString() {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 20; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}


