﻿
$(document).ready(function () {

    /* CUSTOM INVITATION EMAIL TEMPLATE */
    var strInvitationEmailTemplate = $('#custom_invitation_email').val();
    if (strInvitationEmailTemplate != undefined && strInvitationEmailTemplate != "") {
        $("#checkBoxInvitationEmail_data").show();
        $('#checkBoxInvitationEmail').attr('checked', true);
    }
    else {
        $("#checkBoxInvitationEmail_data").hide();
        $('#checkBoxInvitationEmail').attr('checked', false);
    };
    $("#checkBoxInvitationEmail").click(function () {

        var satisfied = $('#checkBoxInvitationEmail').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxInvitationEmail_data").show();
            $('#checkBoxInvitationEmail').attr('checked', true);
            fnGetCustomInviteTemplate();
        }
        else {
            $("#checkBoxInvitationEmail_data").hide();
            $('#checkBoxInvitationEmail').attr('checked', false);
            $('#custom_invitation_email').val("");
        }

    });
    /* CUSTOM INVITATION EMAIL TEMPLATE */

    /* CUSTOM SECURED EMAIL TEMPLATE */
    var strCustomTemplate = $('#custom_encryption_email_html').val();
    if (strCustomTemplate != undefined && strCustomTemplate != "") {
        $("#checkBoxCustomSecuredEmail_data").show();
        $('#checkBoxCustomSecuredEmail').attr('checked', true);
    }
    else {
        $("#checkBoxCustomSecuredEmail_data").hide();
        $('#checkBoxCustomSecuredEmail').attr('checked', false);
    };
    $("#checkBoxCustomSecuredEmail").click(function () {

        var satisfied = $('#checkBoxCustomSecuredEmail').prop('checked');
        if (satisfied != undefined && satisfied == true) {
            $("#checkBoxCustomSecuredEmail_data").show();
            $('#checkBoxCustomSecuredEmail').attr('checked', true);
            fnGetTemplates();
        }
        else {
            $("#checkBoxCustomSecuredEmail_data").hide();
            $('#checkBoxCustomSecuredEmail').attr('checked', false);
            CKEDITOR.instances.custom_encryption_email_html.setData("");
            $('#custom_encryption_email_text').val("");
        }

    });
    /* CUSTOM SECURED EMAIL TEMPLATE */

});

// This function gets the standard Galaxkey Secured Email Templates
function fnGetTemplates() {
    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/CorporateConfiguration/StandardTemplates',
        data: '',
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = jSon['result'];
                if (bResult == false) {
                    $("#dialogMessage").text(jSon['message']);
                    $("#dialog-message").dialog('open');
                }
                else {
                    var strStdHtml = jSon['html'];
                    var strStdText = jSon['text'];
                    CKEDITOR.instances.custom_encryption_email_html.setData(strStdHtml);
                    $('#custom_encryption_email_text').val(strStdText);
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
}

function fnGetCustomInviteTemplate() {

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/CorporateConfiguration/StandardTemplates',
        data: '',
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = jSon['result'];
                if (bResult == false) {
                    $("#dialogMessage").text(jSon['message']);
                    $("#dialog-message").dialog('open');
                }
                else {
                    var strInvitationTextTemplate = jSon['invitation_text_template'];
                    $('#custom_invitation_email').val(strInvitationTextTemplate);
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });


}